/*
 *
/*	
 *	main.cpp
 *
 *	PFFSview - P/ECE Flash File System viewer
 *	Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *
 *	* Sat May 18 20:00:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- 쐬JnB
 *	* Sat May 19 00:00:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- P[XB
 *	@G[`FbN܂łB܂Aꕔ̖}ɑΉĂ܂B
 *	* Sun Sep 01 21:19:00 JST 2002 Naoyuki Sawa <nsawa@north.hokkai.net>
 *	- 2MBP/ECEɑΉB
 */
#define STRICT
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#define __PCEKN__
#include "piece.h"
#include "pieceif.h"
#pragma comment(lib,"pieceif.lib")
#include "resource.h"

#define _VERSION_	"20020901"
#define VERSION_INFO	"PFFSview - P/ECE Flash File System viewer (" _VERSION_ ")\n" \
			"Copyright (C) 2002 Naoyuki Sawa <nsawa@north.hokkai.net>\n" \
			"\n" \
			"L[̐\n" \
			"@meTn\t\t[h\n" \
			"\n" \
			"F̐\n" \
			"@\t\ts\n" \
			"@\t\tG[\n" \
			"@邢\tt@C\n" \
			"@邢VA\tt@CiI𒆁j\n" \
			"@邢\tVXe\n" \
			"@DF\t\t\n" \
			"@邢DF\t"

#define APPNAME		"PFFSVIEW"
#define APPTITLE	"P/ECE Flash File System viewer"

#define MAINFRAMECLASS	APPNAME ".MAINFRAME"
#define FATVIEWCLASS	APPNAME ".FATVIEW"

#define ID_APP_ABOUT	 101
#define IDC_FILE_LIST	1001
#define IDC_FAT_VIEW	1002

#define BLOCKSIZE	4096	/* PFFSZN^TCY */

#define FAT_CELL_COLS	16
#define FAT_CELL_ROWS	((MAXFAT + FAT_CELL_COLS - 1) / FAT_CELL_COLS)
#define FAT_CELL_W	16
#define FAT_CELL_H	10

#define F_UNKNOWN	0	/* s             */
#define F_ERROR		1	/* G[           */
#define F_FILE		2	/* t@C         */
#define F_FILE_SEL	3	/* t@C(I) */
#define F_SYSTEM	4	/* FAT_SYSTEM       */
#define F_INVALID	5	/* FAT_INVALID      */
#define F_FREE		6	/* FAT_FREE         */
#define F_COUNT		7

HINSTANCE g_inst;		/* CX^Xnh */

HBRUSH g_brush[F_COUNT];	/* Z`puV */
COLORREF g_brush_color[F_COUNT] = {
	RGB(255,255,  0),	/* s             */
	RGB(255,  0,  0),	/* G[           */
	RGB(192,192,255),	/* t@C         */
	RGB(192,255,255),	/* t@C(I) */
	RGB(192,255,192),	/* FAT_SYSTEM       */
	RGB(128,128,128),	/* FAT_INVALID      */
	RGB(192,192,192),	/* FAT_FREE         */
};

HWND g_main_frame;		/* Ct[ */
HWND g_file_list;		/* t@CXg */
HWND g_fat_view;		/* FATr[ */

SYSTEMINFO g_si;		/* VXe */
pffsMASTERBLOCK g_msb;		/* ǂݍ񂾃}X^[ubN     */
int g_dir;			/* I𒆂dirCfNX(-1:Ȃ) */

void err(LPCSTR fmt, ...);
void msb_clear();
int msb_load();
LRESULT CALLBACK main_frame_proc(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam);
LRESULT CALLBACK fat_view_proc(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam);
void fat_view_draw(HDC dc);

/****************************************************************************
 *	WinMain
 ****************************************************************************/

int PASCAL
WinMain(HINSTANCE inst, HINSTANCE prev_inst, LPSTR cmd_line, int cmd_show)
{
	int result, i;
	WNDCLASS wc;
	MSG msg;

	/* CX^Xnhi[܂B */
	g_inst = inst;

	/* ܂A}X^[ubN𖳌Ă܂B */
	msb_clear();

	/* Z`puV쐬܂B */
	for(i = 0; i < F_COUNT; i++) {
		g_brush[i] = CreateSolidBrush(g_brush_color[i]);
		if(g_brush[i] == NULL) goto ERR;
	}

	/* Ct[̃EChENXo^܂B */
	memset(&wc, 0, sizeof wc);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hInstance = g_inst;
	wc.lpfnWndProc = main_frame_proc;
	wc.hIcon = LoadIcon(g_inst, MAKEINTRESOURCE(IDR_MAINFRAME));
	wc.lpszClassName = MAINFRAMECLASS;
	result = RegisterClass(&wc);
	if(result == 0) goto ERR;

	/* FATr[̃EChENXo^܂B */
	memset(&wc, 0, sizeof wc);
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.hInstance = g_inst;
	wc.lpfnWndProc = fat_view_proc;
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszClassName = FATVIEWCLASS;
	result = RegisterClass(&wc);
	if(result == 0) goto ERR;

	/* Ct[쐬܂B */
	g_main_frame = CreateWindow(
		MAINFRAMECLASS, APPTITLE,
		WS_OVERLAPPED | WS_BORDER | WS_SYSMENU | WS_MINIMIZEBOX,
		0, 0, 100, 100, /* BTCY0̓_ */
		NULL, NULL, g_inst, NULL);
	if(g_main_frame == NULL) goto ERR;
	ShowWindow(g_main_frame, cmd_show);
	UpdateWindow(g_main_frame);

	/* }X^[ubN[h܂B
	 * t@CXg쐬ꂽłȂƌĂׂ܂I
	 */
	msb_load();

	/* bZ[W[vB */
	while(GetMessage(&msg, NULL, 0, 0)) {
		/* F5L[ꂽA}X^[ubN[h܂B
		 * ꂾ̂߂ɃANZ[^`̂傰Ȃ̂ŁA
		 * ڃnhĂ܂܂B
		 */
		if(msg.message == WM_KEYDOWN && msg.wParam == VK_F5) {
			msb_load();
			continue;
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
ERR:
	err("AvP[VɃG[܂B");
	return -1; /* DUMMY */
}

/****************************************************************************
 *	err
 ****************************************************************************/

void
err(LPCSTR fmt, ...)
{
	char str[256];
	va_list ap;

	/* G[bZ[W\܂B */
	va_start(ap, fmt);
	_vsnprintf(str, sizeof str, fmt, ap);
	va_end(ap);
	MessageBox(NULL, str, APPTITLE, MB_TASKMODAL | MB_ICONSTOP | MB_OK);

#ifdef _DEBUG
	abort(); /* G[_CAO\āAfobO邩₢킹܂B */
#else /*_DEBUG*/
	exit(-1); /* [XrhȂAG[_CAO͕\AI܂B */
#endif /*_DEBUG*/
}

/****************************************************************************
 *	msb_clear
 ****************************************************************************/

void
msb_clear()
{
	if(g_file_list != NULL) SendMessage(g_file_list, LB_RESETCONTENT, 0, 0);
	memset(&g_msb, -1, sizeof g_msb);
	g_dir = -1;
}

/****************************************************************************
 *	msb_load
 ****************************************************************************/

int
msb_load()
{
	int retval, i;
	DIRECTORY* dir;

	/* ݂̃}X^[ubNNA܂B */
	msb_clear();

	/* P/ECEɐڑ܂B */
	retval = ismInit();
	if(retval != 0) goto ERR;

	/* VXe擾܂B */
	retval = ismGetVersion(&g_si, 0/*ismInit()Ŏ擾Ԃ*/);
	if(retval == PIECE_INVALID_VERSION) goto ERR;

	/* }X^[ubNǂݍ݂܂B */
	retval = ismReadMem((unsigned char*)&g_msb, (unsigned long)g_si.pffs_top, sizeof g_msb);
	if(retval != 0) goto ERR;

	/* P/ECEؒf܂B */
	ismExit();

	/* t@CXgݒ肵܂B */
	for(i = 0, dir = g_msb.dir; i < MAXDIR; i++, dir++) {
		if(dir->name[0] == '\x00' || dir->name[0] == '\xFF') continue;
		/* TODO:G[`FbN܂I */
		retval = SendMessage(g_file_list, LB_ADDSTRING, 0, (LPARAM)dir->name);
		SendMessage(g_file_list, LB_SETITEMDATA, retval, i);
	}

	/* r[ĕ`B */
	InvalidateRect(g_fat_view, NULL, FALSE/*d˕`łnj*/);

	return 0;
ERR:
	/* P/ECEؒf܂B */
	ismExit();

	/* }X^[ubN𖳌܂B */
	msb_clear();

	/* r[ĕ`B */
	InvalidateRect(g_fat_view, NULL, FALSE/*d˕`łnj*/);

	/* G[bZ[W\܂B */
	MessageBox(g_main_frame,
		"}X^[ubN̓ǂݍ݂Ɏs܂B",
		APPTITLE, MB_ICONEXCLAMATION | MB_OK);

	return -1;
}

/****************************************************************************
 *	main_frame_proc
 ****************************************************************************/

LRESULT CALLBACK
main_frame_proc(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	int retval, x, y, w, h, id, notify;
	HMENU menu;
	HFONT font;
	LOGFONT lf;
	RECT rc_cli, rc_win;

	switch(msg) {
	case WM_CREATE:
		/* o[W񃁃j[ǉ܂B */
		menu = GetSystemMenu(wnd, FALSE);
		if(menu == NULL) return -1;
		AppendMenu(menu, MF_SEPARATOR, -1, NULL);
		AppendMenu(menu, MF_STRING, ID_APP_ABOUT, "o[W(&A)...");

		/* FATr[쐬܂B */
		x = 0;
		y = 0;
		w = FAT_CELL_W * FAT_CELL_COLS + 1/*E[̋*/;
		h = FAT_CELL_H * FAT_CELL_ROWS + 1/*[̋*/;
		g_fat_view = CreateWindow(
			FATVIEWCLASS, NULL,
			WS_CHILD | WS_VISIBLE,
			x, y, w, h,
			wnd, (HMENU)IDC_FAT_VIEW, g_inst, NULL);
		if(g_fat_view == NULL) return -1;

		/* t@CXg쐬܂B */
		x += w;
		font = GetStockObject(ANSI_FIXED_FONT);
		if(font == NULL) return -1;
		GetObject(font, sizeof lf, &lf);
		w = GetSystemMetrics(SM_CXEDGE) * 2 + /* E̘g̕ */
		    GetSystemMetrics(SM_CXVSCROLL) + /* XN[o[ */
		    lf.lfWidth * 12; /* ő24A8.3xŏ[ */
		g_file_list = CreateWindowEx(
			WS_EX_CLIENTEDGE/*ڂ񂾘g*/,
			"LISTBOX", NULL,
			WS_CHILD | WS_VISIBLE | WS_VSCROLL | LBS_NOTIFY |
			LBS_DISABLENOSCROLL | /* ɃXN[o[\ */
			LBS_NOINTEGRALHEIGHT, /* Cӂ̍ */
			x, y, w, h,
			wnd, (HMENU)IDC_FILE_LIST, g_inst, NULL);
		if(g_file_list == NULL) return -1;
		SendMessage(g_file_list, WM_SETFONT, (WPARAM)font, 0);

		/* Ct[TCY܂B */
		w += x;
		y += h;
		GetWindowRect(wnd, &rc_win);
		GetClientRect(wnd, &rc_cli);
		w += (rc_win.right  - rc_win.left) - rc_cli.right ;
		h += (rc_win.bottom - rc_win.top ) - rc_cli.bottom;
		x = (GetSystemMetrics(SM_CXSCREEN) - w) / 2;
		y = (GetSystemMetrics(SM_CYSCREEN) - h) / 2;
		MoveWindow(wnd, x, y, w, h, TRUE);

		return 0;

	case WM_DESTROY:
		/* AvP[VIv𔭍s܂B */
		PostQuitMessage(0);
		return 0;

	case WM_SETFOCUS:
		/* t@CXgփtH[JXڂ܂B */
		SetFocus(g_file_list);
		return 0;

	case WM_COMMAND:
		id = LOWORD(wparam);
		notify = HIWORD(wparam);
		switch(id) {
		case IDC_FILE_LIST:
			switch(notify) {
			case LBN_SELCHANGE:
				retval = SendMessage(g_file_list, LB_GETCURSEL, 0, 0);
				if(retval != LB_ERR) {
					g_dir = SendMessage(g_file_list, LB_GETITEMDATA, (WPARAM)retval, 0);
				} else {
					g_dir = -1;
				}
				InvalidateRect(g_fat_view, NULL, FALSE/*d˕`łnj*/);
				return 0;
			}
			break;
		}
		break;

	case WM_SYSCOMMAND:
		switch(wparam) {
		case ID_APP_ABOUT:
			MessageBox(wnd, VERSION_INFO, APPTITLE, MB_ICONINFORMATION | MB_OK);
			return 0;
		}
		break;
	}
	return DefWindowProc(wnd, msg, wparam, lparam);
}

/****************************************************************************
 *	fat_view_proc
 ****************************************************************************/

LRESULT CALLBACK
fat_view_proc(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	HDC dc;
	PAINTSTRUCT ps;

	switch(msg) {
	case WM_PAINT:
		dc = BeginPaint(wnd, &ps);
		fat_view_draw(dc);
		EndPaint(wnd, &ps);
		return 0;
	}
	return DefWindowProc(wnd, msg, wparam, lparam);
}

/****************************************************************************
 *	fat_view_draw
 ****************************************************************************/

void
fat_view_draw(HDC dc)
{
	int i, x, y, chain;
	char f[MAXFAT];
	FAT* fat;
	DIRECTORY* dir;
	RECT rc;

	/* ܂ASusvƃ}[NĂ܂B */
	memset(f, F_UNKNOWN, sizeof f);

	/* t@CȊOFAT}[N܂B */
	for(i = 0, fat = g_msb.fat; i < MAXFAT; i++, fat++) {
		if(g_si.pffs_top + i * BLOCKSIZE < g_si.pffs_end) { /* pffs_end = c7ffff(512KB) or dfffff(2MB) */
			switch(fat->chain) {
			case FAT_FREE:
				f[i] = F_FREE;
				break;
			case FAT_INVALID:
				f[i] = F_INVALID;
				break;
			case FAT_SYSTEM:
				f[i] = F_SYSTEM;
				break;
			}
		} else {
			/* 512KB̒ʏP/ECȄꍇA512KB`2MB̗͖̈ƌȂă}[N܂B */
			f[i] = F_INVALID;
		}
	}

	/* et@Cɂ... */
	for(i = 0, dir = g_msb.dir; i < MAXDIR; i++, dir++) {
		if(dir->name[0] == '\x00' || dir->name[0] == '\xFF') continue;
		/* TODO:G[`FbN܂I */
		chain = dir->chain;
		while(chain != FAT_END) {
			f[chain] = i == g_dir ? F_FILE_SEL : F_FILE;
			chain = g_msb.fat[chain].chain;
		}
	}

	/* Z`܂B */
	for(i = 0; i < MAXFAT; i++) {
		x = i % FAT_CELL_COLS;
		y = i / FAT_CELL_COLS;
		rc.left   = FAT_CELL_W * x;
		rc.top    = FAT_CELL_H * y;
		rc.right  = rc.left + FAT_CELL_W;
		rc.bottom = rc.top  + FAT_CELL_H;
		rc.left++;
		rc.top++;
		FillRect(dc, &rc, g_brush[f[i]]);
	}
}
